AddCSLuaFile()

hook.Add("Move", "dronestwo_move", function(ply, move)
	local drone = ply:GetNWEntity("dronestwo_")
	if drone:IsValid() and not drone:IsDroneDestroyed() then
		move:SetOrigin(drone:GetPos() - Vector(0, 0, 65)) 
		return true
	end
end)

hook.Add("KeyPress", "dronestwo_exit", function(ply, key)
	local drone = ply:GetNWEntity("dronestwo_")

	if drone:IsValid() then
		if SERVER then
			if key == IN_USE then
				drone:SetDriver(NULL) 
				drone.wait = CurTime() + 0.3
			end

			if key == IN_SCORE and not drone:IsDroneDestroyed() and CurTime() > drone.wait then
				drone:SetNWBool("thirdperson", not drone:GetNWBool("thirdperson"))
				drone.wait = CurTime() + 0.1
			end
		else
			if key == IN_RELOAD and drone.UseNightVision and not drone:IsDroneDestroyed() and CurTime() > drone.wait then
				drone.nightVision = not drone.nightVision
				drone.wait = CurTime() + 0.1
			end
		end
	end
end)

CreateConVar("dr2_fuelconsumption", 1, FCVAR_ARCHIVE, FCVAR_CHEAT, FCVAR_NOTIFY)
CreateConVar("dr2_ammoconsumption", 1, FCVAR_ARCHIVE, FCVAR_CHEAT, FCVAR_NOTIFY)

if CLIENT then
	game.AddParticles("particles/flame.pcf")

	concommand.Add("dronestwohelp", function(ply)
		print("[Drones 2 Help list]")
		print("WASD - move")
		print("Reload key [R] - night vision")
		print("ALT - special ability (Works only for some drones)")
		print("Jump [Space] / Duck [Ctrl] - move up/down")
		print("At first after you spawned the drone you need to refuel it")
		print("Each drone has Mark. There is 3 Marks")
		print("To refuel Mark 1 drone you should take diesel can")
		print("To refuel Mark 2 drone you should take plasma can and fill it")
		print("Mark 3 drones does not need fuel")
		print("TO TURN OFF FUEL CONSUMPTION YOU NEED TO DISABLE dr2_fuelconsumption.")
		print("TO TURN OFF AMMO CONSUMPTION YOU NEED TO DISABLE dr2_ammoconsumption")
		print("Then you need to restart your server for changes to apply.")
	end)
	
	surface.CreateFont( "dronestwoBigFont", {
		font = "Arial",
		size = 100,
		weight = 0,
		blursize = 0,
		scanlines = 0,
		antialias = true,
		underline = false,
		italic = false,
		strikeout = false,
		symbol = false,
		rotary = false,
		shadow = false,
		additive = false,
		outline = false,
	} )

	local corfov = 0 --FOV variable

	net.Receive("catch_dronestwo_fuel", function()
		local wep = net.ReadEntity()
		local drone = net.ReadEntity()
		local fuel = net.ReadFloat()

		wep.droneNeedRefuel = drone
		wep.Fuel = fuel
	end)

	usermessage.Hook("upd_health_dronestwo", function(data)
		local self = data:ReadEntity()
		local hp = data:ReadFloat()

		if not self:IsValid() then return end

		self.armor = hp
	end)

	usermessage.Hook("upd_fuel_dronestwo", function(data)
		local self = data:ReadEntity()
		local fuel = data:ReadFloat()

		if not self:IsValid() then return end

		self.Fuel = fuel
	end)

	usermessage.Hook("upd_ammo_dronestwo", function(data)
		local self = data:ReadEntity()
		local ammo = data:ReadShort()

		if not self:IsValid() then return end

		self.Ammo = ammo
	end)

	usermessage.Hook("upd_ammo2_dronestwo", function(data)
		local self = data:ReadEntity()
		local ammo = data:ReadShort()

		if not self:IsValid() then return end

		self.Ammo2 = ammo
	end)

	hook.Add("Think", "dronestwo_think", function()
		local ply = LocalPlayer()
		local drone = ply:GetNWEntity("dronestwo_")

		if drone:IsValid() and drone:HasFuel() and not drone:IsDroneDestroyed() and drone.nightVision and not drone:GetNWBool("thirdperson") then
			local dlight = DynamicLight(drone:EntIndex())
			if dlight then
				dlight.pos = drone:GetPos()
				dlight.r = 255
				dlight.g = 255
				dlight.b = 255
				dlight.brightness = 0
				dlight.Decay = 100
				dlight.Size = 1000
				dlight.DieTime = CurTime() + 0.05
			end
		end
	end)

	hook.Add("HUDPaint", "dronestwo_drawhud", function()
		local ply = LocalPlayer()
		local drone = ply:GetNWEntity("dronestwo_")

		if drone:IsValid() and not drone:GetNWBool("thirdperson") then
		
			local x, y = ScrW(), ScrH()

			local textColor = drone.HUD_textColor
			local hudColor = drone.HUD_hudColor
			local drawCrosshair = drone.HUD_drawCrosshair
			local drawRing = drone.enableDefaultZoom
			local drawAmmo = drone.UseAmmo
			local drawAmmo2 = drone.UseAmmo2

			local cam_up = drone.cam_up or 13
			local cam_forward = drone.cam_forward or 1
			local pos = (drone:GetPos() + drone:GetForward() * 10 - drone:GetUp() * cam_up + drone:GetForward() * cam_forward):ToScreen()
			
			if drone:IsDroneDestroyed() then
				x, y = x / 2, y / 2
					
				if not drone.donoisesound then
					drone.donoisesound = true

					timer.Simple(0.2, function() 
						if not drone:IsValid() then return end

						surface.PlaySound("ambient/energy/spark" .. math.random(1, 4) .. ".wav")
						surface.PlaySound("ambient/energy/zap" .. math.random(1, 5) .. ".wav")
						drone.donoisesound = false 
					end)
				end

				draw.SimpleText("SYSTEM DAMAGED", "dronestwoBigFont", x,y, Color(255, 0, 0), TEXT_ALIGN_CENTER)

				return
			end
				
			if drone:HasFuel() then
				if drone.CustomHUD then
					drone.CustomHUD(drone, pos.x, pos.y) 
				end
				
				if not drone.DrawHUD then return end

				surface.SetMaterial(Material("particles/dronestwo_crossring"))
				surface.SetDrawColor(hudColor)

				local size = 120
				surface.DrawTexturedRect(pos.x - (size/2), pos.y - (size/2), size, size)

				surface.SetMaterial(Material("particles/littledrone"))
				surface.DrawTexturedRect(pos.x - 530, pos.y - 11, 22, 22)

				for k, v in pairs(ents.FindInSphere(drone:GetAim(Vector(-40, -40, 0), Vector(40, 40, 0)).HitPos, 400)) do
					if v == drone then continue end
					if v == ply then continue end

					if not v:IsPlayer() and not v:IsNPC() and not v.IS_DRONE and string.sub(v:GetClass(), 1, 6) != "drone_" then continue end
					if v:IsPlayer() and (v:GetNWEntity("drone_") or v:GetNWEntity("dronestwo_")) then continue end
					if v.IS_DRONE and v:IsDroneDestroyed() then continue end

					-- Calculating target position
					local pos = v:GetPos()
					local bone = v:LookupBone("ValveBiped.Bip01_Head1")
					if bone then pos = v:GetBonePosition(bone) end

					local size = (100 - math.Clamp(drone:GetPos():Distance(pos) * 0.04, 20, 80))
					pos = pos:ToScreen()

					surface.SetMaterial(Material("particles/dronestwo_target"))
					surface.SetDrawColor(Color(255, 255, 255, 200))
					surface.DrawTexturedRectRotated(pos.x, pos.y, size, size, CurTime() * 100)
					surface.DrawTexturedRectRotated(pos.x, pos.y, size, size, -CurTime() * 100)

					if drone:GetPrivilegeLvl() > 1 then
						local hp = v:Health()
						if v.armor then hp = v.armor end
						draw.SimpleText("[HP: " .. math.floor(hp) .. "]", "Trebuchet18", pos.x, pos.y + size * 0.6, Color(255, 0, 0), TEXT_ALIGN_CENTER)
					end
				end

				--Fuel
				if drone.shouldConsumeFuel then
					surface.SetDrawColor(hudColor)
					surface.DrawOutlinedRect(pos.x - 260, pos.y - 80, 200, 15)
					surface.DrawRect(pos.x - 255, pos.y - 75, drone.Fuel / drone.MaxFuel * 190, 5)
					draw.SimpleText("Fuel " .. math.floor(drone.Fuel / drone.MaxFuel * 100) .. "%", "Trebuchet24", pos.x - 270, pos.y - 85, textColor, TEXT_ALIGN_RIGHT)

					draw.SimpleText("[" .. math.floor(drone.Fuel) .. " / " .. drone.MaxFuel .. "]", "Trebuchet18", pos.x - 270, pos.y - 56, textColor, TEXT_ALIGN_RIGHT)

					--Fuel lines
					surface.DrawLine(pos.x - 500, pos.y - 29, pos.x - 380, pos.y - 90)
					surface.DrawLine(pos.x - 380, pos.y - 90, pos.x - 50, pos.y - 95)
					surface.DrawLine(pos.x - 50, pos.y - 95, pos.x - 40, pos.y - 40)
				end

				if drone.shouldConsumeAmmo then
					if drawAmmo then
						surface.SetDrawColor(hudColor)
						surface.DrawOutlinedRect(pos.x - 260, pos.y + 55, 200, 15)
						surface.DrawRect(pos.x - 255, pos.y + 60, drone.Ammo / drone.MaxAmmo * 190, 5)
						draw.SimpleText("Ammo " .. math.floor(drone.Ammo / drone.MaxAmmo * 100) .. "%", "Trebuchet24", pos.x - 270, pos.y + 50, textColor, TEXT_ALIGN_RIGHT)

						draw.SimpleText("[" .. drone.Ammo .. " / " .. drone.MaxAmmo .. "]", "Trebuchet18", pos.x - 270, pos.y + 79, textColor, TEXT_ALIGN_RIGHT)
					end

					if drawAmmo2 then
						surface.SetDrawColor(hudColor)
						surface.DrawOutlinedRect(pos.x - 260, pos.y + 105, 200, 15)
						surface.DrawRect(pos.x - 255, pos.y + 110, drone.Ammo2 / drone.MaxAmmo2 * 190, 5)
						draw.SimpleText("Secondary ammo " .. math.floor(drone.Ammo2 / drone.MaxAmmo2 * 100) .. "%", "Trebuchet24", pos.x - 270, pos.y + 100, textColor, TEXT_ALIGN_RIGHT)

						draw.SimpleText("[" .. drone.Ammo2 .. " / " .. drone.MaxAmmo2 .. "]", "Trebuchet18", pos.x - 270, pos.y + 129, textColor, TEXT_ALIGN_RIGHT)
					end
				end

				--HP
				surface.SetDrawColor(hudColor)
				surface.DrawOutlinedRect(pos.x - 405, pos.y - 10, 200, 15)
				surface.DrawRect(pos.x - 400, pos.y - 5, drone.armor / drone.defArmor * 190, 5)
				draw.SimpleText("HP [" .. math.floor(drone.armor) .. "]", "Trebuchet24", pos.x - 500, pos.y - 15, textColor)

				surface.SetDrawColor(hudColor)
				--Long lines
				surface.DrawLine(0, pos.y - 20, pos.x - 40, pos.y - 40)
				surface.DrawLine(0, pos.y + 20, pos.x - 40, pos.y + 40)
				surface.DrawLine(x, pos.y - 20, pos.x + 40, pos.y - 40)
				surface.DrawLine(x, pos.y + 20, pos.x + 40, pos.y + 40)

				--Center lines
				surface.DrawLine(pos.x - 5, pos.y + 5, pos.x - 40, pos.y + 40)
				surface.DrawLine(pos.x - 5, pos.y - 5, pos.x - 40, pos.y - 40)
				surface.DrawLine(pos.x + 5, pos.y + 5, pos.x + 40, pos.y + 40)
				surface.DrawLine(pos.x + 5, pos.y - 5, pos.x + 40, pos.y - 40)

				local current_pos = drone:GetPos()
				current_pos = tostring("X[" .. math.floor(current_pos.x) 
						.. "]  Y[" .. math.floor(current_pos.y) 
						.. "]  Z[" .. math.floor(current_pos.z) .. "]")

				draw.SimpleText(current_pos, "Trebuchet24", pos.x + 100, pos.y - 15, textColor, TEXT_ALIGN_LEFT)
				draw.SimpleText("SPEED [" .. math.floor(drone:GetVelocity():Length()) .. "]", "Trebuchet24", pos.x - 200, pos.y - 25, textColor)
				draw.SimpleText(drone:GetUnit(), "Trebuchet24", pos.x - 200, pos.y - 5, textColor)

				if drone.nightVision then
					surface.SetMaterial(Material("particles/dronestwo_noise"))
					surface.SetDrawColor(Color(255, 255, 255, 1))
					surface.DrawTexturedRect(0, 0, ScrW(), ScrH())

					draw.SimpleText("[Nightvision enabled]", "Trebuchet24", pos.x - 500, pos.y + 50, textColor, TEXT_ALIGN_CENTER)
				end

				if drone.CriticalArmorPoint and drone.armor < drone.CriticalArmorPoint then
					draw.SimpleText("[WARNING! LOW HP]", "Trebuchet24", pos.x, pos.y + 50, Color(255, 0, 0), TEXT_ALIGN_CENTER)
				end

				x, y = x / 2, y / 2 -- Setting variables to center

				--[[if drawRing then
					surface.SetMaterial(Material("particles/dronestwo_ring"))
					surface.SetDrawColor(Color(150, 0, 0, 40))

					local size = corfov * 50
					surface.DrawTexturedRect(x - (size/2), y - (size/2), size, size)
				end]]

				--Crosshair
				if drawCrosshair then
					surface.SetMaterial(Material("particles/dronestwo_crosshair"))
					surface.SetDrawColor(hudColor)

					local size = 50
					surface.DrawTexturedRect(x - (size/2), y - (size/2), size, size)
				end
			else 
				if not drone:IsDroneDestroyed() then
					draw.SimpleText("ALL SYSTEMS OFF", "Trebuchet24", x/2, y/2, Color(255, 0, 0), TEXT_ALIGN_CENTER)
					draw.SimpleText("NEED REFUEL", "Trebuchet24", x/2, y/2+30, Color(255, 0, 0), TEXT_ALIGN_CENTER)
				end
			end
		end
	end)

	local no_drawing = {
		CHudHealth = true,
		CHudBattery = true,
		CHudCrosshair = true
	}
	hook.Add("HUDShouldDraw", "dronestwo_huddraw", function(name)
		local ply = LocalPlayer()
		local drone = ply:GetNWEntity("dronestwo_")

		if drone:IsValid() then
			if drone:GetNWBool("thirdperson") and name == "CHudCrosshair" then return true end
			if no_drawing[name] then return false end
		end
	end)

	hook.Add("RenderScreenspaceEffects", "dronestwo_eff", function()
		local ply = LocalPlayer()
		local drone = ply:GetNWEntity("dronestwo_")

		if drone:IsValid() and drone.DrawEffects and not drone:GetNWBool("thirdperson") then
			local eff_tab = {
				["$pp_colour_addr"] = 0.2,
				["$pp_colour_addg"] = 0,
				["$pp_colour_addb"] = 0.2,
				["$pp_colour_brightness"] = -0.2,
				["$pp_colour_contrast"] = 1,
				["$pp_colour_colour"] = 1.5,
				["$pp_colour_mulr"] = 0,
				["$pp_colour_mulg"] = 0,
				["$pp_colour_mulb"] = 1
			}

			if drone.nightVision and drone:HasFuel() then
				eff_tab = {
					["$pp_colour_addr"] = 0,
					["$pp_colour_addg"] = 0,
					["$pp_colour_addb"] = 0,
					["$pp_colour_brightness"] = -0.2,
					["$pp_colour_contrast"] = 1,
					["$pp_colour_colour"] = 0,
					["$pp_colour_mulr"] = 0,
					["$pp_colour_mulg"] = 0,
					["$pp_colour_mulb"] = 0
				}

				DrawBloom(0.3, 1, 6, 6, 8, 1, 1, 1, 1)
				DrawSharpen(0.65, 6)
				DrawMotionBlur(0.5, 1, 0.02)
			end

			DrawColorModify(eff_tab)
			DrawMaterialOverlay("effects/combine_binocoverlay.vmt", 0)

			if drone.CriticalArmorPoint and drone.armor < drone.CriticalArmorPoint then
				DrawMaterialOverlay("effects/tvscreen_noise002a", 0)
			end

			if drone:IsDroneDestroyed() then 
				eff_tab = {
					["$pp_colour_addr"] = 0,
					["$pp_colour_addg"] = 0,
					["$pp_colour_addb"] = 0,
					["$pp_colour_brightness"] = 0.4,
					["$pp_colour_contrast"] = 1,
					["$pp_colour_colour"] = 0,
					["$pp_colour_mulr"] = 0,
					["$pp_colour_mulg"] = 0,
					["$pp_colour_mulb"] = 0
				}

				DrawColorModify(eff_tab)
				DrawToyTown(10, ScrH())
			end
		end
	end)

	hook.Add("CalcView", "dronestwo_view", function(ply, pos, ang, fov)
		local drone = ply:GetNWEntity("dronestwo_")

		ply.ShouldDisableLegs = false
		if drone:IsValid() then
			ply.ShouldDisableLegs = true --Fixes conflicts with Gmod Legs

			local view = {}

			--Set some constants
			local forward = drone.forward or 100
			local up = drone.up or 1
			local cam_up = drone.cam_up or 13
			local cam_forward = drone.cam_forward or 1

			if drone:GetNWBool("thirdperson") then
				--view.origin = util.QuickTrace(drone:GetPos() + drone:GetUp() * 20, -drone:GetAngles():Forward() * forward + drone:GetUp() * up, drone).HitPos
				
				local stuffang = drone:GetAngles()
				stuffang.r = 0
				view.angles = stuffang + ang

				view.origin = util.TraceLine({
					start = drone:GetPos() + drone:GetUp() * up,
					endpos = drone:GetPos() + drone:GetUp() * up - view.angles:Forward() * forward * 2,
					filter = { drone, drone:GetDriver() },
					mask = MASK_SOLID_BRUSHONLY
				}).HitPos
			else
				view.origin = drone:GetPos() - drone:GetUp() * cam_up + drone:GetForward() * cam_forward
				view.angles = drone:GetAngles() + ang
			end

			--[[ There is no zoom
			-- Zoom :)))))
			if drone.enableDefaultZoom then
				corfov = ply:KeyDown(IN_RELOAD) and math.Approach(corfov, 35, 1) or math.Approach(corfov, fov, 1)
				drone.cl_InZoom = ply:KeyDown(IN_RELOAD)
				fov = corfov
				view.fov = fov
			end]]

			--[[aim = util.TraceLine({
				start = view.origin,
				endpos = view.angles:Forward() * 10000,
				filter = { drone, pl },
				mins = Vector(-30, -30, 0),
				maxs = Vector(30, 30, 0)
			}) ]]
			--aim = util.QuickTrace(view.origin, view.angles:Forward() * 5000, { drone, ply })

			return view
		end
	end)

	hook.Add("PlayerBindPress", "dronestwo_stopbinds", function(ply, bind, p)
		local drone = ply:GetNWEntity("dronestwo_")

		if drone:IsValid() then		
			local tools = {
				"phys_swap",
				"slot",
				"invnext",
				"invprev",
				"lastinv",
				"gmod_tool",
				"gmod_toolmode"
			}
			
			for k, v in pairs(tools) do if bind:find(v) then return true end end
		end
	end)
else
	util.AddNetworkString("catch_dronestwo_fuel")

	hook.Add( "PlayerInitialSpawn", "dronestwo_gethelp", function(ply)
		ply:ChatPrint("[Drones 2] To get help type 'dronestwohelp' into console")
	end)
	
	//hook.Add("Think", "getconv", function()
	//	print(GetConVar("dr2_fuelconsumption"):GetInt())
	//end)
end