AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Default Drone"
ENT.Category        = "Drones 2: Ground"
ENT.Spawnable = false

ENT.Speed = 20
ENT.RotateSpeed = 6
ENT.armor = 250

ENT.SoundName = "vehicles/airboat/fan_blade_idle_loop1.wav"

ENT.forward = 40
ENT.up = 20
ENT.cam_forward = 20
ENT.cam_up = -12

ENT.MaxFuel = 25

ENT.Ammo = 5000
ENT.MaxAmmo = 5000

ENT.NextJump = 0

ENT.WaitPhysics = CurTime()

ENT.Wheels = { }
ENT.WheelsModel = "models/xeon133/offroad/off-road-20.mdl"
ENT.WheelsAxis = Vector(1, 0, 0)
ENT.WheelsAng = Angle(0, 90, 0)
ENT.WheelsMass = 30
ENT.WheelsPos = nil
ENT.Height = 15

function ENT:GetAim(mins, maxs)
	local driver = self:GetDriver()
	if not driver:IsValid() then return nil end

	local pos = self:GetPos() - self:GetUp() * self.cam_up
	local ang = self:GetAngles() + Angle(driver:EyeAngles().p > 0 and 0 or driver:EyeAngles().p, driver:EyeAngles().y, 0)
	
	if not mins and not maxs then return util.QuickTrace(pos, ang:Forward() * 10000, { self, driver }) end
	return util.TraceHull({
		start = pos,
		endpos = ang:Forward() * 10000,
		filter = { self, driver },
		mins = mins,
		maxs = maxs
	})
end

function ENT:GetAimWithDistance(dist)
	local driver = self:GetDriver()
	if not driver:IsValid() then return nil end

	local pos = self:GetPos() - self:GetUp() * self.cam_up
	local ang = self:GetAngles() + Angle(driver:EyeAngles().p > 0 and 0 or driver:EyeAngles().p, driver:EyeAngles().y, 0)
	
	return util.QuickTrace(pos, ang:Forward() * dist, { self, driver })
end

function ENT:GetDriverDirection()
	local driver = self:GetDriver()
	if not driver:IsValid() then return nil end

	return (self:GetAngles() + Angle(driver:EyeAngles().p > 0 and 0 or driver:EyeAngles().p, driver:EyeAngles().y, 0)):Forward()
end

function ENT:InitWheels()
	self.Wheels = { }
	for k, v in pairs(self.WheelsPos) do
		self.Wheels[k] = ents.Create("prop_physics")
		self.Wheels[k]:SetPos(self:LocalToWorld(v))
		self.Wheels[k]:SetModel(self.WheelsModel)
		self.Wheels[k]:SetAngles(self:GetAngles() + self.WheelsAng)
		self.Wheels[k]:Spawn()
		self.Wheels[k]:Activate()
		self.Wheels[k]:GetPhysicsObject():EnableDrag(false)	
		self.Wheels[k]:GetPhysicsObject():SetMass(self.WheelsMass)

		constraint.Axis(self.Wheels[k], self, 0, 0, self.WheelsAxis, v, 0, 0, 1, 0)
		constraint.NoCollide(self, self.Wheels[k], 0, 0)
	end
end

function ENT:RemoveWheels()
	for k, v in pairs(self.Wheels) do SafeRemoveEntity(v) end
end

function ENT:OnRemove()
	self:_OnRemove()

	self:RemoveWheels()
end

function ENT:OnDestroyed() end
function ENT:PhysicsSimulate(phys, delta)
end

function ENT:IsDroneOnGround() return self.isOnGround end
function ENT:UpdateTimePhysics() self.WaitPhysics = RealTime() + 0.5 end

function ENT:PhysicsUpdate(phys)
	if CLIENT then return end
	if self.WaitPhysics < RealTime() then return end

	local ang = phys:GetAngles()
	local avel = phys:GetAngleVelocity()
	local vel = phys:GetVelocity()
	local velLen = vel:Length()
	local mass = phys:GetMass()

	local forward = self:GetForward()
	local up = self:GetUp()

	for k, v in pairs(self.WheelsPos) do
		local corner = self:LocalToWorld(v)

		local tr = util.TraceLine({
			start = corner,
			endpos = corner - up * self.Height,
			filter = { self, self.Wheels[k] }
		})

		self.isOnGround = tr.Hit
	end

	if self:IsDroneOnGround() then
		phys:ApplyForceCenter(-vel * 50)
	end

	if not self:IsDroneEnabled() then return end
	if self:IsDroneDestroyed() then return end
	if not self:HasFuel() then return end
	if not self:IsDroneOnGround() then return end

	local user = self:GetDriver()
	if user:IsValid() then
		self.curSpeed = (user:KeyDown(IN_SPEED) and self.Moving) and math.Approach(self.curSpeed, 2.5, 0.01) or math.Approach(self.curSpeed, 1, 0.01)
		self.Moving = false

		if user:KeyDown(IN_JUMP) and self:IsDroneOnGround() and CurTime() > self.NextJump then
			phys:ApplyForceCenter(vector_up * mass * 500)
			self.NextJump = CurTime() + 2
		end

		if user:KeyDown(IN_FORWARD) then
			self.Moving = true
			phys:ApplyForceCenter(forward * mass * self.Speed * self.curSpeed)

			if user:KeyDown(IN_MOVERIGHT) then
				phys:AddAngleVelocity(Vector(0, 0, -1) * mass * self.RotateSpeed * 0.005)
			end

			if user:KeyDown(IN_MOVELEFT) then
				phys:AddAngleVelocity(Vector(0, 0, 1) * mass * self.RotateSpeed * 0.005)
			end
		end

		if user:KeyDown(IN_BACK) then
			self.Moving = true
			phys:ApplyForceCenter(-forward * mass * self.Speed * self.curSpeed)

			if user:KeyDown(IN_MOVERIGHT) then
				phys:AddAngleVelocity(Vector(0, 0, 1) * mass * self.RotateSpeed * 0.005)
			end

			if user:KeyDown(IN_MOVELEFT) then
				phys:AddAngleVelocity(Vector(0, 0, -1) * mass * self.RotateSpeed * 0.005)
			end
		end
	end

	phys:AddAngleVelocity(Vector(0, -3, 0 ))

	self.LastPhys = CurTime()
end