AddCSLuaFile()

ENT.Base = "base_anim"
ENT.PrintName		= "Generator"
ENT.Category        = "Drones 2: Fuel"
ENT.Spawnable		= true
ENT.Fuel = 0
ENT.armor = 350

if CLIENT then 
	usermessage.Hook("upd_dronestwo_generator", function(data)
		local self = data:ReadEntity()
		local fuel = data:ReadFloat()

		self.Fuel = fuel
	end)

	usermessage.Hook("upd_dronestwo_generator_hp", function(data)
		local self = data:ReadEntity()
		local arm = data:ReadFloat()

		self.armor = arm
	end)
else
	function ENT:SetFuel(n)
		self.Fuel = math.min(200, n)

		umsg.Start("upd_dronestwo_generator")
			umsg.Entity(self)
			umsg.Float(self.Fuel)
		umsg.End()
	end

	function ENT:SetArm(n)
		self.armor = n

		umsg.Start("upd_dronestwo_generator_hp")
			umsg.Entity(self)
			umsg.Float(self.armor)
		umsg.End()
	end
end

function ENT:Initialize()
	if CLIENT then
		local tab = {
			["m"] = { type = "Model", model = "models/props_lab/labpart.mdl", bone = "", rel = "", pos = Vector(-45, 40, 60), angle = Angle(180, 0, 90), size = Vector(7, 7, 7), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["m1"] = { type = "Model", model = "models/props_lab/crystalholder_bars.mdl", bone = "", rel = "", pos = Vector(-45, 45, 60), angle = Angle(0, 0, 0), size = Vector(1.1, 1.1, 1.3), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001*", skin = 0, bodygroup = {} },
			["m2"] = { type = "Model", model = "models/props_lab/reciever_cart.mdl", bone = "", rel = "", pos = Vector(20, 40, 40), angle = Angle(0, 90, 0), size = Vector(1.3, 1.3, 1.3), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m3"] = { type = "Model", model = "models/props_phx/construct/glass/glass_plate2x2.mdl", bone = "", rel = "", pos = Vector(-45, 0, 45), angle = Angle(90, 0, 0), size = Vector(0.2, 0.2, 0.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} }
		}
		self.WElements = table.FullCopy(tab)
		self:CreateModels(self.WElements)

		return
	end

	self:DrawShadow(false)
	self:SetModel("models/props_lab/workspace002.mdl")
	self:PhysicsInit(SOLID_VPHYSICS)
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:GetPhysicsObject():Wake()
end

ENT.Timer = true
function ENT:Think()
	if CLIENT then
		self.WElements["m1"].angle.y = CurTime() * 350

		local col = math.abs(200 + math.sin(CurTime())*55)
		self.WElements["m"].color = Color(col, col, 255)
	end

	if SERVER and self.Timer then
		self.Timer = false

		timer.Simple(1, function()
			if not self:IsValid() then return end

			self.Timer = true
			self:SetFuel(self.Fuel + 2)
		end)
	end

	self:NextThink(CurTime())
	return true
end

--Changed SWEP Construction Kit base code

function ENT:Draw()
	if SERVER then return end

	self:DrawModel()

	--SWEP Construction Kit changed draw code
	if !self.WElements then return end
		
	if !self.wRenderOrder then
		self.wRenderOrder = {}

		for k, v in pairs(self.WElements) do
			table.insert(self.wRenderOrder, 1, k)
		end
	end
		
	for k, name in pairs(self.wRenderOrder) do
		local v = self.WElements[name]
		if !v then self.wRenderOrder = nil break end
			
		local pos, ang

		pos = self:GetPos()
		ang = self:GetAngles()
			
		local model = v.modelEnt
		local sprite = v.spriteMaterial
			
		model:SetPos(pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z )
		ang:RotateAroundAxis(ang:Up(), v.angle.y)
		ang:RotateAroundAxis(ang:Right(), v.angle.p)
		ang:RotateAroundAxis(ang:Forward(), v.angle.r)
		model:SetAngles(ang)

		local matrix = Matrix()
		matrix:Scale(v.size)
		model:EnableMatrix( "RenderMultiply", matrix )
		model:SetMaterial(v.material)
				
		render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
		render.SetBlend(v.color.a/255)
		model:DrawModel()
		render.SetBlend(1)
		render.SetColorModulation(1, 1, 1)
	end

	cam.Start3D2D(self:LocalToWorld(Vector(-45, -4, 49)), self:LocalToWorldAngles(Angle(0, 90, 90)), 0.07)
		surface.SetDrawColor(Color(0, 0, 0))
		surface.DrawOutlinedRect(0, 0, 245, 160)

		surface.SetDrawColor(Color(0, 0, 255))
		surface.DrawRect(5, 5, 235, 150)

		draw.SimpleText("Fuel: " .. self.Fuel .. " / 200", "Trebuchet24", 10, 10, Color(255, 255, 255))
		draw.SimpleText("Health: " .. self.armor, "Trebuchet24", 10, 40, Color(255, 255, 255))
		if self.armor <= 50 then draw.SimpleText("WARNING! LOW HP!", "Trebuchet24", 10, 70, Color(255, 0, 0)) end
	cam.End3D2D()
end

function ENT:OnTakeDamage(dmg)
	if CLIENT then return end

	self:SetArm(self.armor - dmg:GetDamage())

	if self.armor <= 0 then
		SafeRemoveEntity(self)
		--util.BlastDamage(self, self, self:GetPos(), 500, 800)
		for k, v in pairs(ents.FindInSphere(self:GetPos(), 600)) do
			local phys = v:GetPhysicsObject()
			if phys:IsValid() then phys:AddVelocity((v:GetPos() - self:GetPos()):GetNormal() * phys:GetMass() * 10) end
		end

		local ef = EffectData()
		ef:SetOrigin(self:GetPos())
		util.Effect("dronestwo_plasmaboom", ef)

		self:EmitSound("ambient/explosions/explode_"..math.random(1,4)..".wav", 500, 100)
	end
end

if CLIENT then
	ENT.wRenderOrder = nil

	function ENT:CreateModels(tab)
		if !tab then return end

		for k, v in pairs(tab) do
			if (v.type == "Model" and v.model and v.model != "" and (!IsValid(v.modelEnt) or v.createdModel != v.model) and 
					string.find(v.model, ".mdl") and file.Exists (v.model, "GAME")) then
				
				v.modelEnt = ClientsideModel(v.model, RENDER_GROUP_VIEW_MODEL_OPAQUE)
				if (IsValid(v.modelEnt)) then
					v.modelEnt:SetPos(self:GetPos())
					v.modelEnt:SetAngles(self:GetAngles())
					v.modelEnt:SetParent(self)
					v.modelEnt:SetNoDraw(true)
					v.createdModel = v.model
				else
					v.modelEnt = nil
				end
			end
		end
	end

	function table.FullCopy(tab)
		if !tab then return nil end
		
		local res = {}
		for k, v in pairs(tab) do
			if type(v) == "table" then
				res[k] = table.FullCopy(v)
			elseif type(v) == "Vector" then
				res[k] = Vector(v.x, v.y, v.z)
			elseif type(v) == "Angle" then
				res[k] = Angle(v.p, v.y, v.r)
			else
				res[k] = v
			end
		end
		
		return res
	end
end
